#ifndef PRINTER_H_
#define PRINTER_H_

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <math.h>
#include <sys/types.h>
#include <limits.h>
#include <signal.h>
#include <getopt.h>
#include <unistd.h>

#define ABS(x) (((x))>0?(x):(-x))
#define MAXLENGTH 500
#define MAXCLAUSE 10000000
#define MAXATOM 2000
#define STOREBLOCK 2000000

struct Formula{
  int *clauseU[MAXCLAUSE];
  int *clauseE[MAXCLAUSE];
  int numclause;
  int numatom;
  int numatomU;
  int numatomE;
  int atoms[MAXATOM];//1 if they are in the Universal, 2 in the Existential
  int atomU[MAXATOM];
  int atomE[MAXATOM];
  int sizeU[MAXCLAUSE];
  int sizeE[MAXCLAUSE];
  int *occurence[2*MAXATOM+1];
  int numoccurence[2*MAXATOM+1];
};

struct Subformula{
  int clause[MAXCLAUSE]; //1 if it is 0 if it is not
  int numclause;
  int numatoms;
};

/**
 * Processing file function
 * It reads the input of the QBF formula
 * and fills the data structure.
 */
void processQBFFile(char*);
void processFile(FILE*);

/**
 * Processing file with assignment
 * Process the assignment to the universal quantifiers
 */
void processAssigFile(char*);

/**
 * Processing Arguments
 * Initializes the filename variables
 * and verifies the correct usage of the
 * program
 */
void parseArgs(char**,int);

/**
 * Generates the subformula from the given input
 */
void exitSubformula();

void generateSubformula();

#endif /*PRINTER_H_*/
